diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-mac-header.h ns-3.47/src/wifi/model/wifi-mac-header.h
--- ns-3.46/src/wifi/model/wifi-mac-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-mac-header.h	2026-02-16 16:08:49.870231000 -0800
@@ -148,6 +148,7 @@
      * Fill the Address 1 field with the given address.
      *
      * @param address the address to be used in the Address 1 field
+     * @hidecaller
      */
     void SetAddr1(Mac48Address address);
     /**
@@ -175,6 +176,7 @@
      * @param type the WifiMacType for the header
      * @param resetToDsFromDs whether the ToDs and FromDs flags
      *        should be reset.
+     * @hidecaller
      */
     virtual void SetType(WifiMacType type, bool resetToDsFromDs = true);
     /**
@@ -293,6 +295,7 @@
      * Return the address in the Address 1 field.
      *
      * @return the address in the Address 1 field
+     * @hidecaller
      */
     Mac48Address GetAddr1() const;
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-mode.h ns-3.47/src/wifi/model/wifi-mode.h
--- ns-3.46/src/wifi/model/wifi-mode.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-mode.h	2026-02-16 16:08:49.871231000 -0800
@@ -138,6 +138,8 @@
      *
      * @returns the Modulation Class (Section 9.7.8 "Modulation classes"; IEEE 802.11-2012)
      * to which this WifiMode belongs.
+     *
+     * @hidecaller
      */
     WifiModulationClass GetModulationClass() const;
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-phy.cc ns-3.47/src/wifi/model/wifi-phy.cc
--- ns-3.46/src/wifi/model/wifi-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-phy.cc	2026-02-16 16:08:49.873231000 -0800
@@ -172,7 +172,7 @@
                           "Number of transmission power levels available between "
                           "TxPowerStart and TxPowerEnd included.",
                           UintegerValue(1),
-                          MakeUintegerAccessor(&WifiPhy::m_nTxPower),
+                          MakeUintegerAccessor(&WifiPhy::m_nTxPowerLevels),
                           MakeUintegerChecker<uint8_t>())
             .AddAttribute("TxPowerEnd",
                           "Maximum available transmission level (dBm).",
@@ -502,7 +502,7 @@
     if (IsInitialized())
     {
         // provide CCA busy information upon registering a PHY listener
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
     }
 }
 
@@ -536,6 +536,10 @@
 {
     NS_LOG_FUNCTION(this << threshold);
     m_ccaEdThreshold = threshold;
+    if (IsInitialized())
+    {
+        SwitchMaybeToCcaBusy();
+    }
 }
 
 dBm_u
@@ -595,16 +599,16 @@
 }
 
 void
-WifiPhy::SetNTxPower(uint8_t n)
+WifiPhy::SetNTxPowerLevels(uint8_t n)
 {
     NS_LOG_FUNCTION(this << +n);
-    m_nTxPower = n;
+    m_nTxPowerLevels = n;
 }
 
 uint8_t
-WifiPhy::GetNTxPower() const
+WifiPhy::GetNTxPowerLevels() const
 {
-    return m_nTxPower;
+    return m_nTxPowerLevels;
 }
 
 void
@@ -728,20 +732,19 @@
 dBm_u
 WifiPhy::GetPower(uint8_t powerLevel) const
 {
+    NS_ASSERT_MSG((powerLevel >= WIFI_MIN_TX_PWR_LEVEL) &&
+                      (powerLevel < (WIFI_MIN_TX_PWR_LEVEL + m_nTxPowerLevels)),
+                  "Invalid TX power level");
     NS_ASSERT(m_txPowerBase <= m_txPowerEnd);
-    NS_ASSERT(m_nTxPower > 0);
-    dBm_u dbm;
-    if (m_nTxPower > 1)
+    NS_ASSERT(m_nTxPowerLevels > 0);
+    NS_ASSERT((m_nTxPowerLevels > 1) || (m_txPowerBase == m_txPowerEnd));
+    auto power{m_txPowerBase};
+    if (m_nTxPowerLevels > 1)
     {
-        dbm = m_txPowerBase + dB_u{powerLevel * (m_txPowerEnd - m_txPowerBase) / (m_nTxPower - 1)};
+        power += dB_u{(powerLevel - WIFI_MIN_TX_PWR_LEVEL) * (m_txPowerEnd - m_txPowerBase) /
+                      (m_nTxPowerLevels - 1)};
     }
-    else
-    {
-        NS_ASSERT_MSG(m_txPowerBase == m_txPowerEnd,
-                      "cannot have TxPowerEnd != TxPowerStart with TxPowerLevels == 1");
-        dbm = m_txPowerBase;
-    }
-    return dbm;
+    return power;
 }
 
 Time
@@ -1307,7 +1310,10 @@
          * state are added to the event list and are employed later to figure
          * out the state of the medium after the switching.
          */
-        SwitchMaybeToCcaBusy(nullptr);
+        Simulator::Schedule(GetChannelSwitchDelay(), [=, this]() {
+            NS_LOG_DEBUG("Channel switching completed: update CCA indication");
+            SwitchMaybeToCcaBusy();
+        });
     }
 }
 
@@ -2218,6 +2224,10 @@
 WifiPhy::SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu /* = nullptr */)
 {
     NS_LOG_FUNCTION(this);
+    if (!IsStateIdle() && !IsStateCcaBusy())
+    {
+        return;
+    }
     GetLatestPhyEntity()->SwitchMaybeToCcaBusy(ppdu);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-phy-common.h ns-3.47/src/wifi/model/wifi-phy-common.h
--- ns-3.46/src/wifi/model/wifi-phy-common.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-phy-common.h	2026-02-16 16:08:49.872231000 -0800
@@ -57,6 +57,9 @@
 /// vector of spectrum bands
 using WifiSpectrumBands = std::vector<WifiSpectrumBandInfo>;
 
+/// A map of the received power for each band
+using RxPowerWattPerChannelBand = std::map<WifiSpectrumBandInfo, Watt_u>;
+
 /**
  * @ingroup wifi
  * Compare two bands.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-phy.h ns-3.47/src/wifi/model/wifi-phy.h
--- ns-3.46/src/wifi/model/wifi-phy.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-phy.h	2026-02-16 16:08:49.873231000 -0800
@@ -69,6 +69,9 @@
     /**
      * @brief Get the type ID.
      * @return the object TypeId
+     *
+     * Call graph was not generated because of its size.
+     * @hidecallgraph
      */
     static TypeId GetTypeId();
 
@@ -252,6 +255,8 @@
      * @param staId the STA-ID of the recipient (only used for MU)
      *
      * @return the total amount of time this PHY will stay busy for the transmission of these bytes.
+     *
+     * @hidecaller
      */
     static Time CalculateTxDuration(uint32_t size,
                                     const WifiTxVector& txVector,
@@ -860,15 +865,15 @@
      * minimum level and the maximum level. Transmission power levels are
      * equally separated (in dBm) with the minimum and the maximum included.
      *
-     * @param n the number of available levels
+     * @param numLevels the number of available levels
      */
-    void SetNTxPower(uint8_t n);
+    void SetNTxPowerLevels(uint8_t numLevels);
     /**
      * Return the number of available transmission power levels.
      *
      * @return the number of available transmission power levels
      */
-    uint8_t GetNTxPower() const;
+    uint8_t GetNTxPowerLevels() const;
     /**
      * Sets the transmission gain.
      *
@@ -1665,7 +1670,7 @@
     dB_u m_rxGain;                     //!< Reception gain
     dBm_u m_txPowerBase;               //!< Minimum transmission power
     dBm_u m_txPowerEnd;                //!< Maximum transmission power
-    uint8_t m_nTxPower;                //!< Number of available transmission power levels
+    uint8_t m_nTxPowerLevels;          //!< Number of available transmission power levels
     dBm_per_MHz_u m_powerDensityLimit; //!< the power density limit
 
     bool m_powerRestricted; //!< Flag whether transmit power is restricted by OBSS PD SR
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-phy-state-helper.cc ns-3.47/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.46/src/wifi/model/wifi-phy-state-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-phy-state-helper.cc	2026-02-16 16:08:49.872231000 -0800
@@ -526,7 +526,7 @@
     {
         m_startCcaBusy = now;
     }
-    m_endCcaBusy = std::max(m_endCcaBusy, now + duration);
+    m_endCcaBusy = now + duration;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-phy-state-helper.h ns-3.47/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.46/src/wifi/model/wifi-phy-state-helper.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-phy-state-helper.h	2026-02-16 16:08:49.872231000 -0800
@@ -336,14 +336,14 @@
      * TracedCallback signature for transmit event.
      *
      * @param [in] packet The received packet.
-     * @param [in] mode   The transmission mode of the packet.
+     * @param [in] mode The transmission mode of the packet.
      * @param [in] preamble The preamble of the packet.
-     * @param [in] power  The transmit power level.
+     * @param [in] powerLevel The transmit power level.
      */
     typedef void (*TxTracedCallback)(Ptr<const Packet> packet,
                                      WifiMode mode,
                                      WifiPreamble preamble,
-                                     uint8_t power);
+                                     uint8_t powerLevel);
 
     /**
      * Notify all WifiPhyListener objects of the given PHY event.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-remote-station-manager.cc ns-3.47/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.46/src/wifi/model/wifi-remote-station-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-remote-station-manager.cc	2026-02-16 16:08:49.873231000 -0800
@@ -106,13 +106,15 @@
                           WifiModeValue(),
                           MakeWifiModeAccessor(&WifiRemoteStationManager::m_nonUnicastMode),
                           MakeWifiModeChecker())
-            .AddAttribute("DefaultTxPowerLevel",
-                          "Default power level to be used for transmissions. "
-                          "This is the power level that is used by all those WifiManagers that do "
-                          "not implement TX power control.",
-                          UintegerValue(0),
-                          MakeUintegerAccessor(&WifiRemoteStationManager::m_defaultTxPowerLevel),
-                          MakeUintegerChecker<uint8_t>())
+            .AddAttribute(
+                "DefaultTxPowerLevel",
+                "Default power level to be used for transmissions. "
+                "This is the power level that is used by all those WifiManagers that do "
+                "not implement TX power control.",
+                UintegerValue(WIFI_MIN_TX_PWR_LEVEL), // corresponds to WifiPhy::TxPowerStart
+                MakeUintegerAccessor(&WifiRemoteStationManager::m_defaultTxPowerLevel),
+                MakeUintegerChecker<uint8_t>(WIFI_MIN_TX_PWR_LEVEL,
+                                             std::numeric_limits<uint8_t>::max()))
             .AddAttribute("ErpProtectionMode",
                           "Protection mode used when non-ERP STAs are connected to an ERP AP: "
                           "Rts-Cts or Cts-To-Self",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-remote-station-manager.h ns-3.47/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.46/src/wifi/model/wifi-remote-station-manager.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-remote-station-manager.h	2026-02-16 16:08:49.874230900 -0800
@@ -1559,6 +1559,7 @@
      *
      * @param address the address of the station
      * @return WifiRemoteStationState corresponding to the address
+     * @hidecaller
      */
     std::shared_ptr<WifiRemoteStationState> LookupState(Mac48Address address) const;
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-standard-constants.h ns-3.47/src/wifi/model/wifi-standard-constants.h
--- ns-3.46/src/wifi/model/wifi-standard-constants.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-standard-constants.h	2026-02-16 16:08:49.874230900 -0800
@@ -23,47 +23,50 @@
 
 /// Wi-Fi Time Unit value in microseconds (see IEEE 802.11-2020 sec. 3.1)
 /// Used to initialize WIFI_TU
-WIFI_EXPORT extern const Time WIFI_TU;
+inline const Time WIFI_TU = MicroSeconds(1024);
 
 /// aRxPHYStartDelay value to use when waiting for a new frame in the context of EMLSR operations
 /// (Sec. 35.3.17 of 802.11be D3.1)
-extern const Time EMLSR_RX_PHY_START_DELAY;
+inline const Time EMLSR_RX_PHY_START_DELAY = MicroSeconds(20);
 
 /// aSIFSTime value for OFDM (20 MHz channel spacing)
 /// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
-extern const Time OFDM_SIFS_TIME_20MHZ;
+inline const Time OFDM_SIFS_TIME_20MHZ = MicroSeconds(16);
 
 /// aSlotTime duration for OFDM (20 MHz channel spacing)
 /// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
-extern const Time OFDM_SLOT_TIME_20MHZ;
+inline const Time OFDM_SLOT_TIME_20MHZ = MicroSeconds(9);
 
 /// aSIFSTime value for OFDM (10 MHz channel spacing)
 /// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
-extern const Time OFDM_SIFS_TIME_10MHZ;
+inline const Time OFDM_SIFS_TIME_10MHZ = MicroSeconds(32);
 
 /// aSlotTime duration for OFDM (10 MHz channel spacing)
 /// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
-extern const Time OFDM_SLOT_TIME_10MHZ;
+inline const Time OFDM_SLOT_TIME_10MHZ = MicroSeconds(13);
 
 /// aSIFSTime value for OFDM (5 MHz channel spacing)
 /// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
-extern const Time OFDM_SIFS_TIME_5MHZ;
+inline const Time OFDM_SIFS_TIME_5MHZ = MicroSeconds(64);
 
 /// aSlotTime duration for OFDM (5 MHz channel spacing)
 /// (Table 17-21 "OFDM PHY characteristics" of 802.11-2020)
-extern const Time OFDM_SLOT_TIME_5MHZ;
+inline const Time OFDM_SLOT_TIME_5MHZ = MicroSeconds(21);
 
 /// aSIFSTime duration for DSSS (Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2020)
-extern const Time DSSS_SIFS_TIME;
+inline const Time DSSS_SIFS_TIME = MicroSeconds(10);
 
 /// aSlotTime duration for DSSS (Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2020)
-extern const Time DSSS_SLOT_TIME;
+inline const Time DSSS_SLOT_TIME = MicroSeconds(20);
 
 /// maximum propagation delay
-WIFI_EXPORT extern const Time MAX_PROPAGATION_DELAY;
+inline const Time MAX_PROPAGATION_DELAY = MicroSeconds(1);
 
 /// The aMediumSyncThreshold defined by Sec. 35.3.16.18.1 of 802.11be D4.0
-WIFI_EXPORT extern const Time MEDIUM_SYNC_THRESHOLD;
+inline const Time MEDIUM_SYNC_THRESHOLD = MicroSeconds(72);
+
+/// minimum TX power level value
+static constexpr uint8_t WIFI_MIN_TX_PWR_LEVEL{1};
 
 /// Subcarrier frequency spacing in Hz (Table 19-6 "Timing-related constants" of 802.11-2020)
 static constexpr uint32_t SUBCARRIER_FREQUENCY_SPACING{312500};
@@ -84,6 +87,22 @@
 /// The length in octets of the IEEE 802.11 MAC FCS field
 static constexpr uint16_t WIFI_MAC_FCS_LENGTH{4};
 
+/// The value for aPSDUMaxLength in Table 15-5 (DSSS PHY characteristics), Table 17-21 (OFDM PHY
+/// characteristics) and Table 18-5 (ERP characteristics) of 802.11-2020
+static constexpr uint32_t WIFI_PSDU_MAX_LENGTH{4095};
+
+/// The value for aPSDUMaxLength in Table 19-25 (HT PHY characteristics) of 802.11-2020
+static constexpr uint32_t WIFI_PSDU_MAX_LENGTH_HT{65'535};
+
+/// The value for aPSDUMaxLength in Table 21-28 (VHT PHY characteristics) of 802.11-2020
+static constexpr uint32_t WIFI_PSDU_MAX_LENGTH_VHT{4'692'480};
+
+/// The value for aPSDUMaxLength in Table 27-54 (HE PHY characteristics) of 802.11ax-2021
+static constexpr uint32_t WIFI_PSDU_MAX_LENGTH_HE{6'500'631};
+
+/// The value for aPSDUMaxLength in Table 36-70 (EHT PHY characteristics) of 802.11be D7.0
+static constexpr uint32_t WIFI_PSDU_MAX_LENGTH_EHT{15'523'200};
+
 /// The minimum value for dot11RTSThreshold (C.3 MIB detail in IEEE Std 802.11-2020)
 static constexpr uint32_t WIFI_MIN_RTS_THRESHOLD{0};
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-tx-vector.cc ns-3.47/src/wifi/model/wifi-tx-vector.cc
--- ns-3.46/src/wifi/model/wifi-tx-vector.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-tx-vector.cc	2026-02-16 16:08:49.874230900 -0800
@@ -24,7 +24,7 @@
 {
 
 WifiTxVector::WifiTxVector()
-    : m_txPowerLevel(1),
+    : m_txPowerLevel(WIFI_MIN_TX_PWR_LEVEL),
       m_preamble(WIFI_PREAMBLE_LONG),
       m_channelWidth(MHz_u{20}),
       m_guardInterval(NanoSeconds(800)),
@@ -293,6 +293,7 @@
 void
 WifiTxVector::SetTxPowerLevel(uint8_t powerlevel)
 {
+    NS_ABORT_MSG_IF(powerlevel < WIFI_MIN_TX_PWR_LEVEL, "TX power level set below allowed range");
     m_txPowerLevel = powerlevel;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-tx-vector.h ns-3.47/src/wifi/model/wifi-tx-vector.h
--- ns-3.46/src/wifi/model/wifi-tx-vector.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-tx-vector.h	2026-02-16 16:08:49.874230900 -0800
@@ -152,12 +152,14 @@
      *
      * @param staId the station ID for MU
      * @returns the selected payload transmission mode
+     * @hidecaller
      */
     WifiMode GetMode(uint16_t staId = SU_STA_ID) const;
     /**
      * Sets the selected payload transmission mode
      *
      * @param mode the payload WifiMode
+     * @hidecaller
      */
     void SetMode(WifiMode mode);
     /**
@@ -197,6 +199,7 @@
     void SetPreambleType(WifiPreamble preamble);
     /**
      * @returns the channel width
+     * @hidecaller
      */
     MHz_u GetChannelWidth() const;
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/wifi-types.h ns-3.47/src/wifi/model/wifi-types.h
--- ns-3.46/src/wifi/model/wifi-types.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/wifi-types.h	2026-02-16 16:08:49.875231000 -0800
@@ -97,7 +97,7 @@
     struct SegmentWithoutUnits
     {
         uint8_t number{};                            ///< channel number
-        double width{};                              ///< channel width in MHz
+        MHz_u width{};                               ///< channel width in MHz
         WifiPhyBand band{WIFI_PHY_BAND_UNSPECIFIED}; ///< PHY band
         uint8_t p20Index{};                          ///< primary20 index
 
@@ -109,7 +109,7 @@
          * @param b the PHY band
          * @param i the primary20 index
          */
-        SegmentWithoutUnits(uint8_t n, double w, WifiPhyBand b, uint8_t i)
+        SegmentWithoutUnits(uint8_t n, MHz_u w, WifiPhyBand b, uint8_t i)
             : number(n),
               width(w),
               band(b),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/yans-wifi-phy.cc ns-3.47/src/wifi/model/yans-wifi-phy.cc
--- ns-3.46/src/wifi/model/yans-wifi-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/yans-wifi-phy.cc	2026-02-16 16:08:49.875231000 -0800
@@ -94,7 +94,7 @@
 void
 YansWifiPhy::TraceSignalArrival(Ptr<const WifiPpdu> ppdu, double rxPowerDbm, Time duration)
 {
-    NS_LOG_FUNCTION(this << ppdu);
+    NS_LOG_FUNCTION(this << ppdu << rxPowerDbm << duration.As(Time::US));
     m_signalArrivalCb(ppdu, rxPowerDbm, ppdu->GetTxDuration());
 }
 
